import processing.core.*; 

class UltraStar {
  PApplet myPApplet;
  Song mySong;

  UltraStar (PApplet newPApplet) {
    myPApplet = newPApplet;
  }

  Song parseUS(String fileName) {

    mySong = new Song();  
    String fileLines[] = myPApplet.loadStrings(fileName);

    boolean newLine = true;
    Line curLine = null;
    boolean newWord = true;
    Word curWord = null;
    int startFrame, endFrame = 19800318;
    for (int i=0; i < fileLines.length; i++) {

      // Find Keys

      String[] keyMatch = myPApplet.match(fileLines[i],"#(.*):(.*)");
      if (keyMatch != null) {
        mySong.setKey(keyMatch[1], keyMatch[2]);
      }

      // Find Breaks

      String[] breakMatch = myPApplet.match(fileLines[i], "^-[ ]?(\\d+)[ ]?(\\d*)");
      if (breakMatch != null) {
        int breakStartFrame = myPApplet.round(mySong.getOffset() + (Integer.valueOf(breakMatch[1]).intValue() * mySong.getFPB()));
        int breakEndFrame = breakStartFrame;
        if (!breakMatch[2].equals(""))
          breakEndFrame = myPApplet.round(mySong.getOffset() + (Integer.valueOf(breakMatch[2]).intValue() * mySong.getFPB()));

        mySong.addBreak(breakStartFrame, breakEndFrame);
        newLine = true;
        newWord = true;
      }

      // Find Syllables

      String[] sylMatch = myPApplet.match(fileLines[i], "[:*] (\\d+) (\\d+) [-]?(\\d+) (.*)"); 

      if (sylMatch != null) {  
        startFrame = myPApplet.round(mySong.getOffset() + (Integer.valueOf(sylMatch[1]).intValue() * mySong.getFPB()));
        String syllableString = sylMatch[4].toUpperCase();

        if (!syllableString.trim().equals("-") && !syllableString.trim().equals("")) {

          if (syllableString.charAt(0) == ' ')
            newWord = true;

          if (syllableString.charAt(0) == ' ' && newLine)
            syllableString = syllableString.substring(1);

          if (newWord) {
            if (curWord != null) {
              //myPApplet.println(curWord.getLetters());
              curWord.setEndFrame(endFrame);                          
              curLine.addWord(curWord);
            }

            curWord = new Word(startFrame);
            newWord = false;
          }

          if (newLine) {
            if (curLine != null) {
              curLine.setEndFrame(endFrame);   
              mySong.addLine(curLine);
            }

            curLine = new Line(startFrame); 
            newLine = false;
          }

          Syllable curSyllable = new Syllable(startFrame,syllableString);
          endFrame = myPApplet.round(mySong.getOffset() + ((Integer.valueOf(sylMatch[1]).intValue() + Integer.valueOf(sylMatch[2]).intValue()) * mySong.getFPB()));          
          curSyllable.setEndFrame(endFrame);
          curWord.addSyllable(curSyllable);


          if (syllableString.charAt(syllableString.length()-1) == ' ')
            newWord = true;        
        }
      }
    }

    if (curWord != null) {
      //myPApplet.println(curWord.getLetters());
              curWord.setEndFrame(endFrame);         
      curLine.addWord(curWord);
    }

    if (curLine != null) {
      //myPApplet.println(curLine.getLetters());
              curLine.setEndFrame(endFrame);         
      mySong.addLine(curLine);
    }


    return mySong;
  }
}



